/*
 *  init.c
 *
 *  Initialize the data.
 *
 *  Copyright (C) 2008  Huang Guan
 *
 *  2008-02-05 Created.
 *
 *  Description: This file mainly includes the functions about 
 *               Data Initializaion
 *               Data Cleanup
 *               
 */


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include "myqq.h"
#include "mysocket.h"
#include "protocol.h"
#include "packet.h"
#include "debug.h"

myqq_info_t	myqq;

EXPORT int myqq_init()
{
	memset( &myqq, 0, sizeof( myqq_info_t ) );
	packet_list_init();
	myqq.version = 0x1b0e;
	pthread_mutex_init( &myqq.buddy_mutex, NULL );
	pthread_mutex_init( &myqq.group_mutex, NULL );
	return 0;
}

EXPORT void myqq_cleanup()
{
	if( myqq.status == ST_ONLINE )
		myqq_logout();
	
}
