//MyQQ Defines
#ifndef _MYQQDEF_H
#define _MYQQDEF_H

#ifdef __WIN32__
typedef unsigned int uint;
typedef unsigned short ushort;
#endif

#ifdef MYQQLIB
#define EXPORT __declspec(dllexport) __stdcall 
#else
#define EXPORT __declspec(dllimport) __stdcall
#endif

#define MAX_PASSWORD 32

#define LM_OFFLINE	0
#define LM_NORMAL	1
#define LM_HIDDEN	2
#define LM_AWAY	3

#define ST_OFFLINE	0
#define ST_LOGGING	1
#define ST_REDIRECT	2	//¼
#define ST_WRPASS	6	//
#define ST_ONLINE	3
#define ST_ERROR	9	//


#define MAX_BUDDY		512
#define MAX_GROUP		100
#define MAX_BUDDY_INFO	45
#define BUDDY_INFO_LEN	256
#define MAX_NAME_LEN		64
#define GROUP_NOTICE_LEN	256
#define GROUP_DESC_LEN	256
#define MAX_GROUP_MEMBER	300

//delegaters
typedef void (* messenger) ( uint uid, char* nick, time_t time, char* msg );
typedef void (* group_messenger) ( uint uid, char* nick, uint int_uid, char* group_name,
	time_t time, char* msg );
typedef void (*newstatus) ( uint uid, char* nick, int status );
//////////////////////////////////////////////////////////////
//             ** EXTERN FUNCTIONS **
//
/* ¼ */
EXPORT int myqq_login( uint uid, char* password, int mode );
/* ע */
EXPORT void myqq_logout();
/* ı״̬ LM_NORMAL LM_AWAY: 뿪 LM_HIDDEN */
EXPORT void myqq_change_status( int mode );
/* ȡ״ֵ̬ȡֵͬϵĲȡֵ */
EXPORT int myqq_get_status();
/* Ϣ */
EXPORT int myqq_send_im_to_buddy( uint uid, char* msg, int wait );
/* ϢȺ */
EXPORT int myqq_send_im_to_group( uint int_uid, char* msg, int wait );
/* ȡб */
EXPORT int myqq_get_buddy_list( char* buf, int size, char online );
/* ȡȺб */
EXPORT int myqq_get_group_list( char* buf, int size );
/* ȡȺԱб */
EXPORT int myqq_get_group_member_list( uint int_uid, char* buf, int size, char online );
/* úϢ֪ͨĻص */
EXPORT void myqq_delegate_buddy_msg( messenger msgr );
/* ȺϢ֪ͨĻص */
EXPORT void myqq_delegate_group_msg( group_messenger msgr );
/* ú״̬ı֪ͨĻص */
EXPORT void myqq_delegate_buddy_status( newstatus msgr );
/* ȡϢ */
EXPORT int myqq_get_buddy_info( uint uid, char* buf, int size );
/* ȡȺϢ */
EXPORT int myqq_get_group_info( uint uid, char* buf, int size );
/* ɺIDȡ */
EXPORT const char* myqq_get_buddy_name( uint uid );
/* ȺIDȡ */
EXPORT const char* myqq_get_group_name( uint int_uid );
/* ºбߺб */
EXPORT void myqq_update_buddy_list();
/* ȺϢȺԱȺ߳ԱϢ */
EXPORT void myqq_update_group_list();
/* ȴݰ */
EXPORT int myqq_wait( int sec ); //wait for every packet is sent out.
/* ʼMyQQݣʹ֮ǰ */
EXPORT int myqq_init(); //initialize the data
/* ͷMyQQݣڲʹʱ */
EXPORT void myqq_cleanup();
//

#endif //_MYQQ_H
