#ifndef _PACKET_H
#define _PACKET_H

#include <sys/types.h>
#include "myqq.h"


typedef struct __attribute__ ((packed)) myqq_prot_packet_s{
	char		headflag;	//0x02 normally
	ushort		version;
	ushort		command;
	ushort		seqno;
	union{
		uint	uid;
		char	data_in[1];
	};
	char		data_out[1];
}myqq_prot_packet_t;

typedef struct myqq_packet_item_s{
	myqq_prot_packet_t*	packet;
	int			type;	//PACKET_IN or PACKET_OUT
	time_t			time;
	int			send_times;
	int			packet_len;
}myqq_packet_item_t;

#define MAX_PACKETS		256
#define MAX_PACKET_SIZE	65536

#define PACKET_IN	1
#define PACKET_OUT	2

myqq_prot_packet_t* packet_alloc( int len, int type );
void packet_free( myqq_prot_packet_t* packet );
int packet_send( myqq_prot_packet_t* packet, int len );
int packet_recv( myqq_prot_packet_t* packet, int len );
void packet_list_init();
void packet_list_cleanup();
myqq_prot_packet_t* packet_match( myqq_prot_packet_t* p1 );
myqq_prot_packet_t* packet_timeout( int secs, int* len, int* send_times );

#endif	//_PACKET_H
